import random

class Polje(object):
    __slots__ = ["w", "h", "N_min", "mine", "odkrito", "N_neodkritih_praznih"]
    
    def __init__(self, **kwargs):
        if 'm' in kwargs:
            self.w, self.h, self.N_min = kwargs['w'],kwargs['h'],kwargs['m']
            self.mine = [ [False]*self.w for i in range(self.h) ]
            potencialne = set([(a,b) for a in xrange(self.w) for b in xrange(self.h)])
            potencialne -= set([(0,0), (self.w-1, 0), (0, self.h-1), (self.w-1, self.h-1)])
            for x,y in random.sample(potencialne, self.N_min):
                self.mine[y][x] = True
        
        if 'fnm' in kwargs:
            fl = open(kwargs['fnm'], 'r').readlines()
            hdr, field = fl[0], fl[1:]
            self.w,self.h = map(int, hdr.split())
            self.mine = [[c=='*' for c in vrstica.strip('\r\n')] for vrstica in field[:self.h]]
            self.N_min = sum(sum(v) for v in self.mine)
        
        self.N_neodkritih_praznih = self.w * self.h - self.N_min
        self.odkrito = [ [False]*self.w for i in range(self.h)]
    
    def sosednjih(self, x, y):
        "Vrne stevilo min na sosednjih celicah"
        return sum(1 if self.mine[yp][xp] else 0 for xp in range(x-1,x+2) for yp in range(y-1,y+2) if xp >= 0 and yp >= 0 and xp < self.w and yp < self.h and (xp,yp) != (x,y))
    
    def pohodi(self, x, y, stej=True):
        "Oznaci celico (x,y) kot pohojeno"
        bum = self.mine[y][x]
        sosednjih_min = self.sosednjih(x,y)
        fail = False
        if stej:
            if self.odkrito[y][x]:
                print "Odprl ze odkrito polje!"
                fail = True
            else:
                self.odkrito[y][x] = True
                if not bum:
                    self.N_neodkritih_praznih -= 1
        return (bum, sosednjih_min, fail)
    
    def neodkrito(self):
        "Vrne True, ce je se kaksna neodkrita celica."
        return self.N_neodkritih_praznih > 0

    def izberi_prazno(self):
        "Vrne nakljucno neodkrito celico."
        return random.choice([(x,y) for x in range(self.w) for y in range(self.h) if not self.mine[y][x]])

    def izpis(self):
        "Izpise polje"
        print '.' + '_.' * self.w
        for vrstica in self.mine:
            print '|' + '|'.join(['*' if m else '_' for m in vrstica]) + '|' 

    def izpis_sosednjih(self):
        "Izpise polje s stevilom sosednjih min za vsako celico"
        print '.' + '_.' * self.w
        for y in range(self.h):
            vrstica = [self.sosednjih(x, y) for x in range(self.w)]
            print '|' + '|'.join([str(x) if x > 0 else ' ' for x in vrstica]) + '|' 

    def dump(self, fnm):
        "Zapise polje v datoteko fnm"
        f = open(fnm, "w")
        f.write('%d %d\n' % (self.w, self.h))
        for vrstica in self.mine:
            f.write(''.join('*' if x else ' ' for x in vrstica) + '\n')
        f.close()
